#-*- coding: utf-8 -*-

'''
Secondo esempio (example_02.py) : Inserimento controlli;
                                  sullo sfondo trasparente ...

Per l'inserimento di controlli con contemporanea presenza della
label con l'immagine di background ho utilizza "anche" il
gestore di geometria "grid", malgrado l'utilizzo di place, cosa che
non uso "tranquillamente".

La trasparenza dello sfondo per le label, in tkinter è os-dipendente,
in linux (che io uso) non è possibile, se si sviluppa in windows
decommentare la riga con le istruzioni
self.wm_attributes('-transparentcolor', 'grey')
dovrebbe definire il colore trasparente e, quindi, applicare la
trasparenza ai widget che lo utilizzano - NON POSSO TESTARLO
'''

import tkinter as tk
from PIL import Image, ImageTk

class MainWin(tk.Tk):
    def __init__(self, img, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.title('Test background image & controls')
        self.img = Image.open(img)
        self.img_copy = self.img.copy()
        self.bg_image = ImageTk.PhotoImage(self.img)
        self.bg_label = tk.Label(self, image=self.bg_image)
        self.bg_label.place(x=0, y=0, relwidth=1.0, relheight=1.0)
        self.load = True
        self.bg_label.bind('<Configure>', self._resize_background)
        # Stabilisco il colore 'grey' per la trasparenza - solo x windows
        # poi lo assegno quale colore di sfondo alle label, decommentare
        # la linea sottostante
        # self.wm_attributes('-transparentcolor', 'grey')
        lbl = tk.Label(self, text='Utente : ', font='bold',
                       fg='red', bg='grey', justify='right')
        lbl.grid(row=0, column=0, sticky='e', padx=20, pady=4)
        self.user = tk.Entry(self, relief='sunken', border=2)
        self.user.grid(row=0, column=1, sticky='ew', padx=20, pady=4)
        lbl = tk.Label(self, text='Password : ', font='bold',
                       fg='red', bg='grey', justify='right')
        lbl.grid(row=1, column=0, sticky='e', padx=20, pady=4)
        self.pwd = tk.Entry(self, relief='sunken', border=2)
        self.pwd.grid(row=1, column=1, sticky='ew', padx=20, pady=4)
        btn = tk.Button(self, text='Accedi', bg='green', fg='yellow',
                        font='bold', border=3)
        btn.grid(row=2, column=0, pady=20)
        btn = tk.Button(self, text='Esci', bg='red', fg='yellow',
                        font='bold', border=3, command=self.destroy)
        btn.grid(row=2, column=1, pady=20)
        self.grid_columnconfigure(0, weight=1)
        self.grid_columnconfigure(1, weight=1)
        self.grid_rowconfigure(0, weight=1)
        self.grid_rowconfigure(1, weight=1)
        

    def _verify_init(self):
        w = self.img.width
        h = self.img.height
        self.configure(width=w, height=h)
        self.update()
        self.minsize(w, h)
        center_window(self)
        self.load = False
        
    def _resize_background(self, event):
        if self.load: self._verify_init()
        w = event.width
        h = event.height
        self.img = self.img_copy.resize((w,h))
        self.bg_image = ImageTk.PhotoImage(self.img)
        self.bg_label.configure(image=self.bg_image)


def center_window(gui):
    l = gui.winfo_screenwidth()
    a = gui.winfo_screenheight()
    wx = gui.winfo_reqwidth()
    wy = gui.winfo_reqheight()
    gui.geometry('{}x{}+{}+{}'.format(wx, wy, (l-wx)//2, (a-wy)//2))
    

if __name__ == '__main__':
    win = MainWin('resource/hal.png')
    win.mainloop()
